

import java_cup.runtime.*;
import java.util.Vector;


%%
%class Lexer
%line
%column

%cup

%{

public void yyerror() {
      System.out.println("error line " +yyline + " column " +yycolumn
      + " " +yytext());
}


%}


id      = [a-zA-Z][a-zA-Z0-9_]*
nb      = [0-9]+
doub   = ([0-9]+)[.]([0-9+]+) 
comment = ( [^*] | \*+[^/*] )*

%%

/* -------------------------------------------------
	Changement d'tat lexical
   ------------------------------------------------- */

"Variables"         {return new Symbol(sym.VAR);}
"Expressions"       {return new Symbol(sym.EXPR);}




/* -------------------------------------------------
	Dclaration de variables
   ------------------------------------------------- */

"int"             {return new Symbol(sym.INT);}
"float"           {return new Symbol(sym.FLOAT);}





/* -------------------------------------------------
	Separateurs
   ------------------------------------------------- */



"("      { return new Symbol(sym.LPAR); }
")"      { return new Symbol(sym.RPAR); }
"+"      { return new Symbol(sym.PLUS); }
"-"      { return new Symbol(sym.MOINS); }
"*"      { return new Symbol(sym.MULT); }
"/"	 { return new Symbol(sym.DIV); }
":="     { return new Symbol(sym.AFF); }




/* -------------------------------------------------
	Variables
   ------------------------------------------------- */

{nb}     { return new Symbol(sym.NB, yytext()); }
{doub}  { return new Symbol(sym.DOUBLE, yytext()); }
{id}     { return new Symbol(sym.ID, yytext()); }
\"[^"\n]*["\n] { return new Symbol(sym.STRING, yytext()); }


/* -------------------------------------------------
	Commentaires - Caracteres non pris en compte
   ------------------------------------------------- */

"/*" [^*] {comment} "*"+ "/"   {}
"//" [^\n\r]* [\n|\r|\r\n]     {}
[\ |\t|\n|\r|\r\n]             {}



/* -------------------------------------------------
	Error
   ------------------------------------------------- */

.    { yyerror(); }
